sh-setup: don't let eval output to be shell-expanded.
[git/barrbrain.git] / git-stash.sh
blob9cabd5dc2cdbdd5de98acb3a0c839dfb07a3c9f3
1 #!/bin/sh
2 # Copyright (c) 2007, Nanako Shiraishi
4 USAGE='[ | list | show | apply | clear]'
6 SUBDIRECTORY_OK=Yes
7 OPTIONS_SPEC=
8 . git-sh-setup
9 require_work_tree
10 cd_to_toplevel
12 TMP="$GIT_DIR/.git-stash.$$"
13 trap 'rm -f "$TMP-*"' 0
15 ref_stash=refs/stash
17 no_changes () {
18 git diff-index --quiet --cached HEAD &&
19 git diff-files --quiet
22 clear_stash () {
23 if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
24 then
25 git update-ref -d refs/stash $current
29 save_stash () {
30 stash_msg="$1"
32 if no_changes
33 then
34 echo >&2 'No local changes to save'
35 exit 0
37 test -f "$GIT_DIR/logs/$ref_stash" ||
38 clear_stash || die "Cannot initialize stash"
40 # Make sure the reflog for stash is kept.
41 : >>"$GIT_DIR/logs/$ref_stash"
43 # state of the base commit
44 if b_commit=$(git rev-parse --verify HEAD)
45 then
46 head=$(git log --abbrev-commit --pretty=oneline -n 1 HEAD)
47 else
48 die "You do not have the initial commit yet"
51 if branch=$(git symbolic-ref -q HEAD)
52 then
53 branch=${branch#refs/heads/}
54 else
55 branch='(no branch)'
57 msg=$(printf '%s: %s' "$branch" "$head")
59 # state of the index
60 i_tree=$(git write-tree) &&
61 i_commit=$(printf 'index on %s\n' "$msg" |
62 git commit-tree $i_tree -p $b_commit) ||
63 die "Cannot save the current index state"
65 # state of the working tree
66 w_tree=$( (
67 rm -f "$TMP-index" &&
68 cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
69 GIT_INDEX_FILE="$TMP-index" &&
70 export GIT_INDEX_FILE &&
71 git read-tree -m $i_tree &&
72 git add -u &&
73 git write-tree &&
74 rm -f "$TMP-index"
75 ) ) ||
76 die "Cannot save the current worktree state"
78 # create the stash
79 if test -z "$stash_msg"
80 then
81 stash_msg=$(printf 'WIP on %s' "$msg")
82 else
83 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
85 w_commit=$(printf '%s\n' "$stash_msg" |
86 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
87 die "Cannot record working tree state"
89 git update-ref -m "$stash_msg" $ref_stash $w_commit ||
90 die "Cannot save the current status"
91 printf >&2 'Saved "%s"\n' "$stash_msg"
94 have_stash () {
95 git rev-parse --verify $ref_stash >/dev/null 2>&1
98 list_stash () {
99 have_stash || return 0
100 git log --pretty=oneline -g "$@" $ref_stash |
101 sed -n -e 's/^[.0-9a-f]* refs\///p'
104 show_stash () {
105 flags=$(git rev-parse --no-revs --flags "$@")
106 if test -z "$flags"
107 then
108 flags=--stat
110 s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@")
112 w_commit=$(git rev-parse --verify "$s") &&
113 b_commit=$(git rev-parse --verify "$s^") &&
114 git diff $flags $b_commit $w_commit
117 apply_stash () {
118 git diff-files --quiet ||
119 die 'Cannot restore on top of a dirty state'
121 unstash_index=
122 case "$1" in
123 --index)
124 unstash_index=t
125 shift
126 esac
128 # current index state
129 c_tree=$(git write-tree) ||
130 die 'Cannot apply a stash in the middle of a merge'
132 # stash records the work tree, and is a merge between the
133 # base commit (first parent) and the index tree (second parent).
134 s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
135 w_tree=$(git rev-parse --verify "$s:") &&
136 b_tree=$(git rev-parse --verify "$s^1:") &&
137 i_tree=$(git rev-parse --verify "$s^2:") ||
138 die "$*: no valid stashed state found"
140 unstashed_index_tree=
141 if test -n "$unstash_index" && test "$b_tree" != "$i_tree"
142 then
143 git diff-tree --binary $s^2^..$s^2 | git apply --cached
144 test $? -ne 0 &&
145 die 'Conflicts in index. Try without --index.'
146 unstashed_index_tree=$(git-write-tree) ||
147 die 'Could not save index tree'
148 git reset
151 eval "
152 GITHEAD_$w_tree='Stashed changes' &&
153 GITHEAD_$c_tree='Updated upstream' &&
154 GITHEAD_$b_tree='Version stash was based on' &&
155 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
158 if git-merge-recursive $b_tree -- $c_tree $w_tree
159 then
160 # No conflict
161 if test -n "$unstashed_index_tree"
162 then
163 git read-tree "$unstashed_index_tree"
164 else
165 a="$TMP-added" &&
166 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
167 git read-tree --reset $c_tree &&
168 git update-index --add --stdin <"$a" ||
169 die "Cannot unstage modified files"
170 rm -f "$a"
172 git status || :
173 else
174 # Merge conflict; keep the exit status from merge-recursive
175 status=$?
176 if test -n "$unstash_index"
177 then
178 echo >&2 'Index was not unstashed.'
180 exit $status
184 # Main command set
185 case "$1" in
186 list)
187 shift
188 if test $# = 0
189 then
190 set x -n 10
191 shift
193 list_stash "$@"
195 show)
196 shift
197 show_stash "$@"
199 apply)
200 shift
201 apply_stash "$@"
203 clear)
204 clear_stash
206 help | usage)
207 usage
210 if test $# -gt 0 && test "$1" = save
211 then
212 shift
214 save_stash "$*" && git-reset --hard
216 esac